#pragma once

#include "FTState.h"

#include "FTSLayoutOffset.h"

namespace FileTransferState
{
	class CFTStateRecvBase : public CFTState
	{
	public:
		CFTStateRecvBase(UIChatFileElement * pUIElem);
	protected:
		virtual void _CalcFileNameSize(const CPoint& ptOffset);
		virtual void _SetControlPos(const CPoint& ptPos, CSize& sz, DWORD dwFlags);
		virtual void _CalcProgressExtraStatusSize(const CPoint& ptOffset);
		virtual void _DrawGroupButtom(Graphics *pGraph, const PointF& ptGdiPOffset,
									RectF rc, Image* pImage, CString strText);
		virtual Image* _GetBubbleImage( BOOL bMine, int nIndex );
	protected:

		static const int m_nButtonToText_X = 1;
	};

	class CStateRecvInit : public CFTStateRecvBase
	{
	public:
		CStateRecvInit(UIChatFileElement * pUIElem);
		~CStateRecvInit(void);
	protected:
		virtual void _CalcProgressSize(const CPoint& ptOffset);
		virtual void _CalcButtonsSize(const CPoint& ptOffset);
		virtual BOOL _DrawButton(Graphics *pGraph, const PointF& ptGdiPOffset);
		//btn_talk_down.png
		//virtual void _CalcButtonsSize(const CPoint& ptOffset);
		//virtual BOOL _DrawButton(Graphics *pGraph, const PointF& ptGdiPOffset);

		virtual void _OnButtonClick();
	private:
		Image* m_pImageDown;
	};

	class CStateRecvProgress : public CFTStateRecvBase
	{
	public:
		CStateRecvProgress(UIChatFileElement * pUIElem);
		~CStateRecvProgress(void);
	protected:
		virtual void _OnButtonClick();
		virtual void _CalcProgressSize(const CPoint& ptOffset);
		virtual void _CalcButtonsSize(const CPoint& ptOffset);
		virtual BOOL _DrawButton(Graphics *pGraph, const PointF& ptGdiPOffset);
		static const int m_nProgressbarLeftEdge = 18;
		static const int m_nProgressbarRightEdge = 29;

		static const int m_nButtonRightEdge = 12;
	};

	class CStateRecvComplete : public CFTStateRecvBase
	{
	public:
		CStateRecvComplete(UIChatFileElement * pUIElem);
		~CStateRecvComplete(void);
		virtual void _OnButtonClick();
		virtual void _OnFileNameClick();
		virtual void _CalcProgressSize(const CPoint& ptOffset);
		virtual void _CalcButtonsSize(const CPoint& ptOffset);
		virtual BOOL _DrawButton(Graphics *pGraph, const PointF& ptGdiPOffset);
	};

	class CStateRecvCancel : public CFTStateRecvBase
	{
	public:
		CStateRecvCancel(UIChatFileElement * pUIElem);
		~CStateRecvCancel(void);
		virtual void _OnButtonClick();
		virtual void _CalcProgressSize(const CPoint& ptOffset);
		virtual void _CalcButtonsSize(const CPoint& ptOffset);
		virtual void _CalcDividerSize(const CPoint& ptOffset);
		virtual BOOL _DrawButton(Graphics *pGraph, const PointF& ptGdiPOffset);

	protected:
		static const int m_nDividerWidth = 1;
	};

	class CStateRecvError : public CFTStateRecvBase
	{
	public:
		CStateRecvError(UIChatFileElement * pUIElem);
		~CStateRecvError(void);
		virtual void _OnButtonClick();
		void _CalcDividerSize(const CPoint& ptOffset);
		void _CalcButtonsSize( const CPoint& ptOffset );
		void _CalcProgressSize( const CPoint& ptOffset );
		virtual BOOL _DrawButton(Graphics *pGraph, const PointF& ptGdiPOffset);

	protected:
		static const int m_nDividerWidth = 1;
	};
}